INSERT INTO NNSITUATION(ID, OPIS, INTERNI_OPIS, ALARM, AKT) 
VALUES (14, 'Rented asset', 'Rented asset', 'Y', 'Y');

DROP VIEW V_EVENT_SITUATION;

CREATE OR REPLACE VIEW V_EVENT_SITUATION AS (
	SELECT ES.ID, ES.EVENT, ES.SITUATION, ES.ALARM, ES.PREVENT_EXECUTION, ES.BLOCK_EXECUTION, ES.ACT, ND.OPIS AS EVENT_OPIS, ND.INTERNI_OPIS AS EVENT_INTERNI_OPIS,
  NS.OPIS AS SITUATION_OPIS, NS.INTERNI_OPIS AS SITUATION_INTERNI_OPIS, AC.OPIS AS ALARM_CHECK_OPIS
	FROM EVENT_SITUATION ES
  LEFT OUTER JOIN NDOGODEK ND ON ND.NDOGODEK = ES.EVENT
  LEFT OUTER JOIN NNSITUATION NS ON NS.ID = ES.SITUATION
  LEFT OUTER JOIN ALARM_CHECK AC ON AC.SIFRA = ES.ALARM_CHECK_CODE
);

CREATE TABLE KONT_OSB_PLOVILA_ODNOS (
ID_KONT_OSB_PLOVILA_ODNOS NUMBER NOT NULL,
ID_KONT_OSB_PLOVILA NUMBER NOT NULL,
ODNOS VARCHAR2(3 CHAR) NOT NULL,
CONSTRAINT PK_KONT_OSB_PLOVILA_ODNOS PRIMARY KEY(ID_KONT_OSB_PLOVILA_ODNOS)
);

ALTER TABLE KONT_OSB_PLOVILA_ODNOS
ADD CONSTRAINT KOPO_ID_KONT_OSB_PLOVILA_FK
FOREIGN KEY (ID_KONT_OSB_PLOVILA)
REFERENCES KONT_OSB_PLOVILA(ID_KONT_OSB_PLOVILA);

ALTER TABLE KONT_OSB_PLOVILA_ODNOS
ADD CONSTRAINT KOPO_ODNOS_PLOVILA_KUPCI_FK
FOREIGN KEY (ODNOS)
REFERENCES NNODNOS_PLOVILA_KUPCI(SIFRA);

CREATE INDEX IX_KOPO_ID_KONT_OSB_PLOVILA ON KONT_OSB_PLOVILA_ODNOS(ID_KONT_OSB_PLOVILA);
CREATE INDEX IX_KOPO_ODNOS ON KONT_OSB_PLOVILA_ODNOS(ODNOS);

CREATE SEQUENCE KONT_OSB_PLOVILA_ODNOS_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

DROP VIEW V_KONT_OSB_PLOVILA;

CREATE OR REPLACE VIEW V_KONT_OSB_PLOVILA AS (
  SELECT KOP.ID_KONT_OSB_PLOVILA, KOP.ID_PLOVILA, KOP.ID_OSEBE, KOP.ODNOS, KOP.NOTE, KOP.PREFERRED, KOP.CO_OWNER, KOP.ACTIVE,
  PLOVILA.IME AS PLOVILA_IME, NNPK.OPIS AS ODNOS_OPIS, NNPK.INTERNI_OPIS AS ODNOS_INTERNI_OPIS,
  KUPCI_OSEBA.PRIIMEK AS OSEBA_PRIIMEK, KUPCI_OSEBA.IME AS OSEBA_IME, KUPCI_OSEBA.NASLOV AS OSEBA_NASLOV, KUPCI_OSEBA.MESTO AS OSEBA_MESTO, KUPCI_OSEBA.POSTA AS OSEBA_POSTA,
  (CASE WHEN ((NNPK.PAYER = 'Y' AND NNPK.AKT = 'Y') OR EXISTS(SELECT KOPO.* FROM KONT_OSB_PLOVILA_ODNOS KOPO, NNODNOS_PLOVILA_KUPCI NPK 
  WHERE KOPO.ODNOS = NPK.SIFRA AND NPK.PAYER = 'Y' AND NPK.AKT = 'Y' AND KOPO.ID_KONT_OSB_PLOVILA = KOP.ID_KONT_OSB_PLOVILA)) THEN 'Y' ELSE 'N' END) AS PAYER
  FROM KONT_OSB_PLOVILA KOP
  LEFT OUTER JOIN PLOVILA PLOVILA ON KOP.ID_PLOVILA = PLOVILA.ID
  LEFT OUTER JOIN KUPCI KUPCI_OSEBA ON KOP.ID_OSEBE = KUPCI_OSEBA.ID
  LEFT OUTER JOIN NNODNOS_PLOVILA_KUPCI NNPK ON KOP.ODNOS = NNPK.SIFRA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2317, SYSDATE, '5.5', 2237, 'KontOsbPlovilaOdnos')
;
